{{#if (objLen attrs)}}
<div class="cell cell--{{class}}">
	{{#each attrs as |attr key|}}
		<div class="cell cell--{{key}} cell--attr-{{key}} cell--{{attr.type}}">
			{{#if attr.customLabel}}
				<input type="text" class="input--cell-title" name="system.{{../group}}.{{key}}.userLabel" value="{{#if attr.userLabel}}{{attr.userLabel}}{{else}}{{attr.label}}{{/if}}">
			{{else}}
				<label for="system.{{../group}}.{{key}}.value" class="cell__title">{{attr.label}}</label>
			{{/if}}
			{{#if attr.description}}<p class="cell__description cell__description--attr">{{attr.description}}</p>{{/if}}
			{{!-- Text area --}}
			{{#if (eq attr.type "LongText")}}
				{{editor attr.value target=attr.attrName button=true owner=../owner editable=../editable}}
			{{!-- Checkbox --}}
			{{else if (eq attr.type "Checkbox")}}
				{{#if attr.checkboxLabel}}<label>{{/if}}
				<input type="checkbox" name="system.{{../group}}.{{key}}.value" {{checked attr.value}}/>
				{{#if attr.checkboxLabel}}{{attr.checkboxLabel}}</label>{{/if}}
			{{!-- Number --}}
			{{else if (eq attr.type "Number")}}
				<input type="text" name="system.{{../group}}.{{key}}.value" value="{{attr.value}}" data-dtype="Number"/>
			{{!-- Resource with value/max --}}
			{{else if (eq attr.type "Resource")}}
				<div class="cell__counter flexrow">
					<input type="text" name="system.{{../group}}.{{key}}.value" value="{{attr.value}}" data-dtype="Number"/>
					<span> / </span>
					<input type="text" name="system.{{../group}}.{{key}}.max" value="{{attr.max}}" data-dtype="Number"/>
				</div>
			{{!-- TODO: Replace this with stylized checkboxes per xp pip. --}}
			{{else if (eq attr.type "Xp")}}
				<div class="cell__clock flexrow">
					{{#if attr.steps}}
						{{#each attr.steps as |step stepKey|}}
							<input type="radio" class="attr-xp" data-name="system.{{../../group}}.{{key}}" data-step="{{stepKey}}" {{checked step}}>
						{{/each}}
					{{/if}}
				</div>
			{{!-- TODO: Replace this with checkboxes per clock pip. --}}
			{{else if (eq attr.type "Clock")}}
				<div class="cell__clock flexrow">
					{{#if attr.steps}}
						{{#each attr.steps as |step stepKey|}}
							<input type="checkbox" class="attr-clock" data-name="system.{{../../group}}.{{key}}" data-step="{{stepKey}}" {{checked step}}>
						{{/each}}
					{{/if}}
				</div>
			{{else if (eq attr.type "ListMany") }}
				<ul class="cell__checkboxes flexcol">
					{{#each attr.options as |option optionKey|}}
						<label
							class="flexrow"
							{{#if option.tooltip}}
							data-tooltip="{{option.tooltip}}"
							data-tooltip-direction="UP"
							{{/if}}
						>
							{{#if option.values}}
								{{#each option.values as |suboption suboptionKey|}}
									<input type="checkbox" class="attr-list" name="system.{{../../../group}}.{{key}}.options.{{optionKey}}.values.{{suboptionKey}}.value" {{checked suboption.value}}/>
								{{/each}}
							{{else}}
								<input type="checkbox" class="attr-list" name="system.{{../../group}}.{{key}}.options.{{optionKey}}.value" {{checked option.value}}/>
							{{/if}}
							{{#if (eq option.label "[Text]")}}
								<input type="text" class="input input-title" name="system.{{../../group}}.{{key}}.options.{{optionKey}}.userLabel" value="{{option.userLabel}}">
							{{else}}
								{{option.label}}
							{{/if}}
						</label>
					{{/each}}
				</ul>
			{{else if (eq attr.type "ListOne") }}
				<ul class="cell__radio flexcol">
					{{#each attr.options as |option optionKey|}}
					<label
						class="flexrow"
						{{#if option.tooltip}}
						data-tooltip="{{option.tooltip}}"
						data-tooltip-direction="UP"
						{{/if}}
					>
						<input type="radio" class="attr-list" value="{{@index}}" name="system.{{../../group}}.{{key}}.value" {{checked (softEq attr.value @index)}} />
						{{#if (eq option.label "[Text]")}}
							<input type="text" class="input input-title" id="system.{{../../group}}.{{key}}.options.{{optionKey}}.userLabel" value="{{option.userLabel}}">
						{{else}}
							{{option.label}}
						{{/if}}
					</label>
					{{/each}}
				</ul>
			{{else if (eq attr.type "Roll")}}
				<div class="cell__roll">
					<span class="attr-icon attr-rollable rollable" data-roll="{{attr.value}}" data-label="{{attr.label}}"><i class="fas fa-dice-d6"></i> <i class="fas fa-dice-d6"></i></span>
					<input type="text" class="input input--roll" name="system.{{../group}}.{{key}}.value" value="{{attr.value}}"/>
				</div>
			{{else if (eq attr.type "Track")}}
				<div class="cell__track">
					{{#each attr.steps as |step stepKey|}}
						{{#if step.isValue}}
							<span class="cell__track__element attr-track-value" role="checkbox" data-name="system.{{../../group}}.{{key}}" data-value="{{step.value}}" aria-checked="{{step.checked}}">{{step.label}}</span>
						{{else}}
							<input class="cell__track__element attr-track-step" type="checkbox" data-name="system.{{../../group}}.{{key}}" data-step="{{step.step}}" data-value="{{step.value}}" {{checked step.checked}}>
						{{/if}}
					{{/each}}
					{{#if (and attr.positive.label attr.negative.label) }}
						<span style="grid-column-end: span {{attr.stepsNegative}}" class="cell__track__label">{{attr.negative.label}}</span>
						<span style="grid-column-end: span 1; grid-row: 2"></span>
						<span style="grid-column-end: span {{attr.stepsPositive}}" class="cell__track__label">{{attr.positive.label}}</span>
					{{/if}}
				</div>

			{{!-- Fallback to a text field. --}}
			{{else}}
				<input type="text" class="input input--{{key}}" name="system.{{../group}}.{{key}}.value" value="{{attr.value}}"/>
			{{/if}}
		</div>
	{{/each}}
</div>
{{/if}}